<?php

namespace Ivoz\Kam\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Kam\Domain\Model\Dispatcher\Dispatcher;
use Ivoz\Kam\Domain\Model\Dispatcher\DispatcherInterface;
use Ivoz\Kam\Domain\Model\Dispatcher\DispatcherRepository;
use Doctrine\Persistence\ManagerRegistry;
use Ivoz\Provider\Domain\Model\ApplicationServerSetRelApplicationServer\ApplicationServerSetRelApplicationServer;

/**
 * DispatcherDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class DispatcherDoctrineRepository extends ServiceEntityRepository implements DispatcherRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Dispatcher::class);
    }

    /**
     * @return DispatcherInterface[]
     */
    public function findByApplicationServerId(int $id): array
    {
        $qb = $this->createQueryBuilder('self')
            ->select('self')
            ->leftJoin(
                'self.applicationServerSetRelApplicationServer',
                'rel'
            )
            ->where('rel.applicationServer = :applicationServer')
            ->setParameter('applicationServer', $id);

        return $qb->getQuery()->getResult();
    }

    public function findOneByApplicationServerSetRelApplicationServer(int $id): ?DispatcherInterface
    {
        /** @var DispatcherInterface $response */
        $response = $this->findOneBy([
            'applicationServerSetRelApplicationServer' => $id
        ]);

        return $response;
    }
}
