<?php

namespace Ivoz\Provider\Domain\Model\ConferenceRoom;

use Ivoz\Core\Domain\Model\LoggableEntityInterface;
use Ivoz\Core\Domain\Model\EntityInterface;
use Ivoz\Core\Domain\DataTransferObjectInterface;
use Ivoz\Core\Domain\ForeignKeyTransformerInterface;
use Ivoz\Provider\Domain\Model\Company\CompanyInterface;

/**
* ConferenceRoomInterface
*/
interface ConferenceRoomInterface extends LoggableEntityInterface
{
    public const ANNOUNCEUSERCOUNT_ALWAYS = 'always';

    public const ANNOUNCEUSERCOUNT_FIRST = 'first';

    /**
     * @codeCoverageIgnore
     * @return array<string, mixed>
     */
    public function getChangeSet(): array;

    /**
     * Get id
     * @codeCoverageIgnore
     * @return integer
     */
    public function getId(): ?int;

    /**
     * @param int | null $id
     */
    public static function createDto($id = null): ConferenceRoomDto;

    /**
     * @internal use EntityTools instead
     * @param null|ConferenceRoomInterface $entity
     */
    public static function entityToDto(?EntityInterface $entity, int $depth = 0): ?ConferenceRoomDto;

    /**
     * Factory method
     * @internal use EntityTools instead
     * @param ConferenceRoomDto $dto
     */
    public static function fromDto(DataTransferObjectInterface $dto, ForeignKeyTransformerInterface $fkTransformer): static;

    /**
     * @internal use EntityTools instead
     */
    public function toDto(int $depth = 0): ConferenceRoomDto;

    public function getName(): string;

    public function getPinProtected(): bool;

    public function getPinCode(): ?string;

    public function getMaxMembers(): int;

    public function getAnnounceUserCount(): string;

    public function getCompany(): CompanyInterface;
}
