<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Core\Infrastructure\Persistence\Doctrine\Model\Helper\CriteriaHelper;
use Ivoz\Provider\Domain\Model\HolidayDate\HolidayDate;
use Ivoz\Provider\Domain\Model\HolidayDate\HolidayDateInterface;
use Ivoz\Provider\Domain\Model\HolidayDate\HolidayDateRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * HolidayDateDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<HolidayDate>
 */
class HolidayDateDoctrineRepository extends ServiceEntityRepository implements HolidayDateRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, HolidayDate::class);
    }

    /**
     * @return array
     */
    public function findMatchingDateSiblings(
        HolidayDateInterface $holidayDate
    ) {
        $criteria = CriteriaHelper::fromArray(
            [
                ['id', 'neq', $holidayDate->getId()],
                ['calendar', 'eq', $holidayDate->getCalendar()],
                ['eventDate', 'eq', $holidayDate->getEventDate()->format('Y-m-d')],
            ]
        );

        $qb = $this->createQueryBuilder('self');
        $qb
            ->select('self')
            ->addCriteria($criteria);

        return $qb->getQuery()->getResult();
    }
}
