<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Ivoz\Provider\Domain\Model\Extension\ExtensionInterface;
use Ivoz\Provider\Domain\Model\Ivr\Ivr;
use Ivoz\Provider\Domain\Model\Ivr\IvrRepository;
use Ivoz\Provider\Domain\Model\Voicemail\VoicemailInterface;
use Doctrine\Persistence\ManagerRegistry;

/**
 * IvrDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Ivr>
 */
class IvrDoctrineRepository extends ServiceEntityRepository implements IvrRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Ivr::class);
    }

    /**
     * @return array
     */
    public function findByExtension(ExtensionInterface $extension)
    {
        $qb = $this->createQueryBuilder('self');

        $qb
            ->select('i')
            ->from(Ivr::class, 'i')
            ->where(
                "i.noInputRouteType = 'extension' and i.noInputExtension = " . $extension->getId()
            )
            ->orWhere(
                "i.errorRouteType = 'extension' and i.errorExtension = " . $extension->getId()
            );

        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function findByVoicemail(VoicemailInterface $voicemail)
    {
        $qb = $this->createQueryBuilder('self');

        $qb
            ->select('i')
            ->from(Ivr::class, 'i')
            ->where(
                "i.noInputRouteType = 'voicemail' and i.noInputVoicemail = " . $voicemail->getId()
            )
            ->orWhere(
                "i.errorRouteType = 'voicemail' and i.errorVoicemail = " . $voicemail->getId()
            );

        return $qb->getQuery()->getResult();
    }
}
