<?php

namespace Ivoz\Provider\Infrastructure\Persistence\Doctrine;

use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;
use Ivoz\Provider\Domain\Model\Service\Service;
use Ivoz\Provider\Domain\Model\Service\ServiceInterface;
use Ivoz\Provider\Domain\Model\Service\ServiceRepository;

/**
 * ServiceDoctrineRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 *
 * @template-extends ServiceEntityRepository<Service>
 */
class ServiceDoctrineRepository extends ServiceEntityRepository implements ServiceRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Service::class);
    }

    /**
     * @return ServiceInterface[]
     */
    public function getServicesInGroup(array $ids)
    {
        $qb = $this->createQueryBuilder('s');

        $query = $qb
            ->select('s')
            ->where(
                $qb->expr()->in('s.id', $ids)
            )
            ->getQuery();

        return $query->getResult();
    }

    /**
     * return ServiceInterface
     */
    public function findByIden(string $iden): ?ServiceInterface
    {
        return $this
            ->findOneBy(
                [ "iden" => $iden ]
            );
    }
}
